/*
 * generated by Xtext 2.15.0
 */
package org.sif.dsl.ide.contentassist.antlr;

import com.google.common.collect.ImmutableMap;
import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.Map;
import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.ide.editor.contentassist.antlr.AbstractContentAssistParser;
import org.sif.dsl.ide.contentassist.antlr.internal.InternalSatParser;
import org.sif.dsl.services.SatGrammarAccess;

public class SatParser extends AbstractContentAssistParser {

	@Singleton
	public static final class NameMappings {
		
		private final Map<AbstractElement, String> mappings;
		
		@Inject
		public NameMappings(SatGrammarAccess grammarAccess) {
			ImmutableMap.Builder<AbstractElement, String> builder = ImmutableMap.builder();
			init(builder, grammarAccess);
			this.mappings = builder.build();
		}
		
		public String getRuleName(AbstractElement element) {
			return mappings.get(element);
		}
		
		private static void init(ImmutableMap.Builder<AbstractElement, String> builder, SatGrammarAccess grammarAccess) {
			builder.put(grammarAccess.getSatSolverAccess().getAlternatives(), "rule__SatSolver__Alternatives");
			builder.put(grammarAccess.getAndAccess().getAlternatives_0(), "rule__And__Alternatives_0");
			builder.put(grammarAccess.getAndAccess().getRightAlternatives_1_2_0(), "rule__And__RightAlternatives_1_2_0");
			builder.put(grammarAccess.getPrimaryAccess().getAlternatives(), "rule__Primary__Alternatives");
			builder.put(grammarAccess.getStartAccess().getGroup(), "rule__Start__Group__0");
			builder.put(grammarAccess.getCheckAccess().getGroup(), "rule__Check__Group__0");
			builder.put(grammarAccess.getBiimpliesAccess().getGroup(), "rule__Biimplies__Group__0");
			builder.put(grammarAccess.getBiimpliesAccess().getGroup_1(), "rule__Biimplies__Group_1__0");
			builder.put(grammarAccess.getImpliesAccess().getGroup(), "rule__Implies__Group__0");
			builder.put(grammarAccess.getImpliesAccess().getGroup_1(), "rule__Implies__Group_1__0");
			builder.put(grammarAccess.getOrAccess().getGroup(), "rule__Or__Group__0");
			builder.put(grammarAccess.getOrAccess().getGroup_1(), "rule__Or__Group_1__0");
			builder.put(grammarAccess.getExcludesAccess().getGroup(), "rule__Excludes__Group__0");
			builder.put(grammarAccess.getExcludesAccess().getGroup_1(), "rule__Excludes__Group_1__0");
			builder.put(grammarAccess.getAndAccess().getGroup(), "rule__And__Group__0");
			builder.put(grammarAccess.getAndAccess().getGroup_1(), "rule__And__Group_1__0");
			builder.put(grammarAccess.getNotAccess().getGroup(), "rule__Not__Group__0");
			builder.put(grammarAccess.getPFormulaAccess().getGroup(), "rule__PFormula__Group__0");
			builder.put(grammarAccess.getStartAccess().getChecksAssignment_2(), "rule__Start__ChecksAssignment_2");
			builder.put(grammarAccess.getCheckAccess().getFormulaAssignment_1(), "rule__Check__FormulaAssignment_1");
			builder.put(grammarAccess.getCheckAccess().getSolverAssignment_3(), "rule__Check__SolverAssignment_3");
			builder.put(grammarAccess.getSatSolverAccess().getNameAssignment_0(), "rule__SatSolver__NameAssignment_0");
			builder.put(grammarAccess.getSatSolverAccess().getNameAssignment_1(), "rule__SatSolver__NameAssignment_1");
			builder.put(grammarAccess.getSatSolverAccess().getNameAssignment_2(), "rule__SatSolver__NameAssignment_2");
			builder.put(grammarAccess.getBiimpliesAccess().getRightAssignment_1_2(), "rule__Biimplies__RightAssignment_1_2");
			builder.put(grammarAccess.getImpliesAccess().getRightAssignment_1_2(), "rule__Implies__RightAssignment_1_2");
			builder.put(grammarAccess.getOrAccess().getRightAssignment_1_2(), "rule__Or__RightAssignment_1_2");
			builder.put(grammarAccess.getExcludesAccess().getRightAssignment_1_2(), "rule__Excludes__RightAssignment_1_2");
			builder.put(grammarAccess.getAndAccess().getRightAssignment_1_2(), "rule__And__RightAssignment_1_2");
			builder.put(grammarAccess.getVariableAccess().getIdAssignment(), "rule__Variable__IdAssignment");
		}
	}
	
	@Inject
	private NameMappings nameMappings;

	@Inject
	private SatGrammarAccess grammarAccess;

	@Override
	protected InternalSatParser createParser() {
		InternalSatParser result = new InternalSatParser(null);
		result.setGrammarAccess(grammarAccess);
		return result;
	}

	@Override
	protected String getRuleName(AbstractElement element) {
		return nameMappings.getRuleName(element);
	}

	@Override
	protected String[] getInitialHiddenTokens() {
		return new String[] { "RULE_WS", "RULE_ML_COMMENT", "RULE_SL_COMMENT" };
	}

	public SatGrammarAccess getGrammarAccess() {
		return this.grammarAccess;
	}

	public void setGrammarAccess(SatGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}
	
	public NameMappings getNameMappings() {
		return nameMappings;
	}
	
	public void setNameMappings(NameMappings nameMappings) {
		this.nameMappings = nameMappings;
	}
}
